diff --git a/rsvg-styles.c b/rsvg-styles.c
index 0e6095c..6836894 100644
--- a/rsvg-styles.c
+++ b/rsvg-styles.c
@@ -823,6 +922,32 @@ rsvg_parse_style_pairs (RsvgHandle * ctx, RsvgState * state, RsvgPropertyBag * a
     }
 }
 
+static gboolean
+parse_style_value (const gchar *string, gchar **value, gboolean *important)
+{
+    gchar **strings;
+
+    strings = g_strsplit (string, "!", 2);
+
+    if (strings == NULL || strings[0] == NULL) {
+        g_strfreev (strings);
+        return FALSE;
+    }
+
+    if (strings[1] != NULL && strings[2] == NULL &&
+        g_str_equal (g_strstrip (strings[1]), "important")) {
+        *important = TRUE;
+    } else {
+        *important = FALSE;
+    }
+
+    *value = g_strdup (g_strstrip (strings[0]));
+
+    g_strfreev (strings);
+
+    return TRUE;
+}
+
 /* Split a CSS2 style into individual style arguments, setting attributes
    in the SVG context.
    
@@ -832,56 +957,87 @@ rsvg_parse_style_pairs (RsvgHandle * ctx, RsvgState * state, RsvgPropertyBag * a
 void
 rsvg_parse_style (RsvgHandle * ctx, RsvgState * state, const char *str)
 {
-    int start, end;
-    char *arg;
-
-    start = 0;
-    while (str[start] != '\0') {
-        for (end = start; str[end] != '\0' && str[end] != ';'; end++);
-        arg = g_new (char, 1 + end - start);
-        memcpy (arg, str + start, end - start);
-        arg[end - start] = '\0';
-        rsvg_parse_style_arg (ctx, state, arg);
-        g_free (arg);
-        start = end;
-        if (str[start] == ';')
-            start++;
-        while (str[start] == ' ')
-            start++;
+    gchar **styles;
+    guint i;
+
+    styles = g_strsplit (str, ";", -1);
+    for (i = 0; i < g_strv_length (styles); i++) {
+        gchar **values;
+        values = g_strsplit (styles[i], ":", 2);
+        if (!values)
+            continue;
+
+        if (g_strv_length (values) == 2) {
+            gboolean important;
+            gchar *style_value = NULL;
+            gchar *first_value = values[0];
+            gchar *second_value = values[1];
+            gchar **split_list;
+
+            /* Just remove single quotes in a trivial way.  No handling for any
+             * special character inside the quotes is done.  This relates
+             * especially to font-family names but cases with special characters
+             * are rare.
+             *
+             * We need a real CSS parser, sigh.
+             */
+            split_list = g_strsplit (second_value, "'", -1);
+            second_value = g_strjoinv(NULL, split_list);
+            g_strfreev(split_list);
+
+            if (parse_style_value (second_value, &style_value, &important))
+                rsvg_parse_style_pair (ctx, state,
+                                       g_strstrip (first_value),
+                                       style_value,
+                                       important);
+            g_free (style_value);
+            g_free (second_value);
+        }
+        g_strfreev (values);
     }
+    g_strfreev (styles);
 }
 
 static void
-rsvg_css_define_style (RsvgHandle * ctx, const gchar * style_name, const char *style_def)
+rsvg_css_define_style (RsvgHandle * ctx,
+                       const gchar * selector,
+                       const gchar * style_name,
+                       const gchar * style_value,
+                       gboolean important)
 {
-    GString *str = g_string_new (style_def);
-    char *existing = NULL;
+    GHashTable *styles;
+    gboolean need_insert = FALSE;
 
     /* push name/style pair into HT */
-    existing = (char *) g_hash_table_lookup (ctx->priv->css_props, style_name);
-    if (existing != NULL)
-        g_string_append_len (str, existing, strlen (existing));
-
-    /* will destroy the existing key and value for us */
-    g_hash_table_insert (ctx->priv->css_props, (gpointer) g_strdup ((gchar *) style_name),
-                         (gpointer) str->str);
-    g_string_free (str, FALSE);
+    styles = g_hash_table_lookup (ctx->priv->css_props, selector);
+    if (styles == NULL) {
+        styles = g_hash_table_new_full (g_str_hash, g_str_equal,
+                                        g_free, (GDestroyNotify) style_value_data_free);
+        g_hash_table_insert (ctx->priv->css_props, (gpointer) g_strdup (selector), styles);
+        need_insert = TRUE;
+    } else {
+        StyleValueData *current_value;
+        current_value = g_hash_table_lookup (styles, style_name);
+        if (current_value == NULL || !current_value->important)
+            need_insert = TRUE;
+    }
+    if (need_insert) {
+        g_hash_table_insert (styles,
+                             (gpointer) g_strdup (style_name),
+                             (gpointer) style_value_data_new (style_value, important));
+    }
 }
 
-#ifdef HAVE_LIBCROCO
-
-#include <libcroco/libcroco.h>
-
 typedef struct _CSSUserData {
     RsvgHandle *ctx;
-    GString *def;
+    CRSelector *selector;
 } CSSUserData;
 
 static void
 css_user_data_init (CSSUserData * user_data, RsvgHandle * ctx)
 {
     user_data->ctx = ctx;
-    user_data->def = NULL;
+    user_data->selector = NULL;
 }
 
 static void
@@ -892,54 +1048,56 @@ ccss_start_selector (CRDocHandler * a_handler, CRSelector * a_selector_list)
     g_return_if_fail (a_handler);
 
     user_data = (CSSUserData *) a_handler->app_data;
-    user_data->def = g_string_new (NULL);
+    cr_selector_ref (a_selector_list);
+    user_data->selector = a_selector_list;
 }
 
 static void
 ccss_end_selector (CRDocHandler * a_handler, CRSelector * a_selector_list)
 {
     CSSUserData *user_data;
-    CRSelector *cur;
 
     g_return_if_fail (a_handler);
 
     user_data = (CSSUserData *) a_handler->app_data;
 
-    if (a_selector_list)
-        for (cur = a_selector_list; cur; cur = cur->next) {
-            if (cur->simple_sel) {
-                gchar *style_name = (gchar *) cr_simple_sel_to_string (cur->simple_sel);
-                if (style_name) {
-                    rsvg_css_define_style (user_data->ctx, style_name, user_data->def->str);
-                    g_free (style_name);
-                }
-            }
-        }
-
-    g_string_free (user_data->def, TRUE);
+    cr_selector_unref (user_data->selector);
+    user_data->selector = NULL;
 }
 
 static void
 ccss_property (CRDocHandler * a_handler, CRString * a_name, CRTerm * a_expr, gboolean a_important)
 {
     CSSUserData *user_data;
-    gchar *expr = NULL, *name = NULL;
+    gchar *name = NULL;
     size_t len = 0;
 
     g_return_if_fail (a_handler);
 
     user_data = (CSSUserData *) a_handler->app_data;
 
-    if (a_name && a_expr && user_data->def) {
-        name = (gchar *) cr_string_peek_raw_str (a_name);
-        len = cr_string_peek_raw_str_len (a_name);
-
-        g_string_append_len (user_data->def, (gchar *) name, len);
-        g_string_append (user_data->def, ": ");
-        expr = (gchar *) cr_term_to_string (a_expr);
-        g_string_append_len (user_data->def, expr, strlen (expr));
-        g_free (expr);
-        g_string_append (user_data->def, "; ");
+    if (a_name && a_expr && user_data->selector) {
+        CRSelector *cur;
+        for (cur = user_data->selector; cur; cur = cur->next) {
+            if (cur->simple_sel) {
+                gchar *selector = (gchar *) cr_simple_sel_to_string (cur->simple_sel);
+                if (selector) {
+                    gchar *style_name, *style_value;
+                    name = (gchar *) cr_string_peek_raw_str (a_name);
+                    len = cr_string_peek_raw_str_len (a_name);
+                    style_name = g_strndup (name, len);
+                    style_value = (gchar *)cr_term_to_string (a_expr);
+                    rsvg_css_define_style (user_data->ctx,
+                                           selector,
+                                           style_name,
+                                           style_value,
+                                           a_important);
+                    g_free (selector);
+                    g_free (style_name);
+                    g_free (style_value);
+                }
+            }
+        }
     }
 }
 
@@ -986,14 +1144,16 @@ init_sac_handler (CRDocHandler * a_handler)
     a_handler->unrecoverable_error = ccss_unrecoverable_error;
 }
 
-static void
-rsvg_real_parse_cssbuffer (RsvgHandle * ctx, const char *buff, size_t buflen)
+void
+rsvg_parse_cssbuffer (RsvgHandle * ctx, const char *buff, size_t buflen)
 {
-    enum CRStatus status = CR_OK;
     CRParser *parser = NULL;
     CRDocHandler *css_handler = NULL;
     CSSUserData user_data;
 
+    if (buff == NULL || buflen == 0)
+        return;
+
     css_handler = cr_doc_handler_new ();
     init_sac_handler (css_handler);
 
@@ -1002,16 +1162,16 @@ rsvg_real_parse_cssbuffer (RsvgHandle * ctx, const char *buff, size_t buflen)
 
     /* TODO: fix libcroco to take in const strings */
     parser = cr_parser_new_from_buf ((guchar *) buff, (gulong) buflen, CR_UTF_8, FALSE);
-    status = cr_parser_set_sac_handler (parser, css_handler);
-
-    if (status != CR_OK) {
-        g_warning (_("Error setting CSS SAC handler\n"));
-        cr_parser_destroy (parser);
+    if (parser == NULL) {
+        cr_doc_handler_unref (css_handler);
         return;
     }
 
-    status = cr_parser_set_use_core_grammar (parser, FALSE);
-    status = cr_parser_parse (parser);
+    cr_parser_set_sac_handler (parser, css_handler);
+    cr_doc_handler_unref (css_handler);
+
+    cr_parser_set_use_core_grammar (parser, FALSE);
+    cr_parser_parse (parser);
 
     cr_parser_destroy (parser);
 }
@@ -1021,102 +1181,46 @@ ccss_import_style (CRDocHandler * a_this,
                    GList * a_media_list,
                    CRString * a_uri, CRString * a_uri_default_ns, CRParsingLocation * a_location)
 {
-    if (a_uri) {
-        GByteArray *stylesheet_data;
-        CSSUserData *user_data;
-
-        user_data = (CSSUserData *) a_this->app_data;
-
-        stylesheet_data =
-            _rsvg_acquire_xlink_href_resource ((gchar *) cr_string_peek_raw_str (a_uri),
-                                               rsvg_handle_get_base_uri (user_data->ctx), NULL);
-        if (stylesheet_data) {
-            rsvg_real_parse_cssbuffer (user_data->ctx, (const char *) stylesheet_data->data,
-                                       (size_t) stylesheet_data->len);
-            g_byte_array_free (stylesheet_data, TRUE);
-        }
-    }
-}
-
-#else                           /* !HAVE_LIBCROCO */
-
-static void
-rsvg_real_parse_cssbuffer (RsvgHandle * ctx, const char *buff, size_t buflen)
-{
-    /*
-     * Extremely poor man's CSS parser. Not robust. Not compliant.
-     * See also: http://www.w3.org/TR/REC-CSS2/syndata.html
-     */
-
-    size_t loc = 0;
-
-    while (loc < buflen) {
-        GString *style_name = g_string_new (NULL);
-        GString *style_props = g_string_new (NULL);
-
-        /* advance to the style's name */
-        while (loc < buflen && g_ascii_isspace (buff[loc]))
-            loc++;
-
-        while (loc < buflen && !g_ascii_isspace (buff[loc]))
-            g_string_append_c (style_name, buff[loc++]);
-
-        /* advance to the first { that defines the style's properties */
-        while (loc < buflen && buff[loc++] != '{');
-
-        while (loc < buflen && g_ascii_isspace (buff[loc]))
-            loc++;
+    CSSUserData *user_data = (CSSUserData *) a_this->app_data;
+    char *stylesheet_data;
+    gsize stylesheet_data_len;
+    char *mime_type = NULL;
 
-        while (loc < buflen && buff[loc] != '}') {
-            /* suck in and append our property */
-            while (loc < buflen && buff[loc] != ';' && buff[loc] != '}')
-                g_string_append_c (style_props, buff[loc++]);
-
-            if (loc == buflen || buff[loc] == '}')
-                break;
-            else {
-                g_string_append_c (style_props, ';');
-
-                /* advance to the next property */
-                loc++;
-                while (loc < buflen && g_ascii_isspace (buff[loc]))
-                    loc++;
-            }
-        }
-
-        rsvg_css_define_style (ctx, style_name->str, style_props->str);
-        g_string_free (style_name, TRUE);
-        g_string_free (style_props, TRUE);
+    if (a_uri == NULL)
+        return;
 
-        loc++;
-        while (loc < buflen && g_ascii_isspace (buff[loc]))
-            loc++;
+    stylesheet_data = _rsvg_handle_acquire_data (user_data->ctx,
+                                                 cr_string_peek_raw_str (a_uri),
+                                                 &mime_type,
+                                                 &stylesheet_data_len,
+                                                 NULL);
+    if (stylesheet_data == NULL || 
+        mime_type == NULL || 
+        strcmp (mime_type, "text/css") != 0) {
+        g_free (stylesheet_data);
+        g_free (mime_type);
+        return;
     }
-}
 
-#endif                          /* HAVE_LIBCROCO */
-
-void
-rsvg_parse_cssbuffer (RsvgHandle * ctx, const char *buff, size_t buflen)
-{
-    /* delegate off to the builtin or libcroco implementation */
-    rsvg_real_parse_cssbuffer (ctx, buff, buflen);
+    rsvg_parse_cssbuffer (user_data->ctx, stylesheet_data, stylesheet_data_len);
+    g_free (stylesheet_data);
+    g_free (mime_type);
 }
 
 /* Parse an SVG transform string into an affine matrix. Reference: SVG
    working draft dated 1999-07-06, section 8.5. Return TRUE on
    success. */
 gboolean
-rsvg_parse_transform (double dst[6], const char *src)
+rsvg_parse_transform (cairo_matrix_t *dst, const char *src)
 {
     int idx;
     char keyword[32];
     double args[6];
     int n_args;
     guint key_len;
-    double tmp_affine[6];
+    cairo_matrix_t affine;
 
-    _rsvg_affine_identity (dst);
+    cairo_matrix_init_identity (dst);
 
     idx = 0;
     while (src[idx]) {
@@ -1180,49 +1284,52 @@ rsvg_parse_transform (double dst[6], const char *src)
         if (!strcmp (keyword, "matrix")) {
             if (n_args != 6)
                 return FALSE;
-            _rsvg_affine_multiply (dst, args, dst);
+
+            cairo_matrix_init (&affine, args[0], args[1], args[2], args[3], args[4], args[5]);
+            cairo_matrix_multiply (dst, &affine, dst);
         } else if (!strcmp (keyword, "translate")) {
             if (n_args == 1)
                 args[1] = 0;
             else if (n_args != 2)
                 return FALSE;
-            _rsvg_affine_translate (tmp_affine, args[0], args[1]);
-            _rsvg_affine_multiply (dst, tmp_affine, dst);
+            cairo_matrix_init_translate (&affine, args[0], args[1]);
+            cairo_matrix_multiply (dst, &affine, dst);
         } else if (!strcmp (keyword, "scale")) {
             if (n_args == 1)
                 args[1] = args[0];
             else if (n_args != 2)
                 return FALSE;
-            _rsvg_affine_scale (tmp_affine, args[0], args[1]);
-            _rsvg_affine_multiply (dst, tmp_affine, dst);
+            cairo_matrix_init_scale (&affine, args[0], args[1]);
+            cairo_matrix_multiply (dst, &affine, dst);
         } else if (!strcmp (keyword, "rotate")) {
             if (n_args == 1) {
-                _rsvg_affine_rotate (tmp_affine, args[0]);
-                _rsvg_affine_multiply (dst, tmp_affine, dst);
+
+                cairo_matrix_init_rotate (&affine, args[0] * M_PI / 180.);
+                cairo_matrix_multiply (dst, &affine, dst);
             } else if (n_args == 3) {
-                _rsvg_affine_translate (tmp_affine, args[1], args[2]);
-                _rsvg_affine_multiply (dst, tmp_affine, dst);
+                cairo_matrix_init_translate (&affine, args[1], args[2]);
+                cairo_matrix_multiply (dst, &affine, dst);
 
-                _rsvg_affine_rotate (tmp_affine, args[0]);
-                _rsvg_affine_multiply (dst, tmp_affine, dst);
+                cairo_matrix_init_rotate (&affine, args[0] * M_PI / 180.);
+                cairo_matrix_multiply (dst, &affine, dst);
 
-                _rsvg_affine_translate (tmp_affine, -args[1], -args[2]);
-                _rsvg_affine_multiply (dst, tmp_affine, dst);
+                cairo_matrix_init_translate (&affine, -args[1], -args[2]);
+                cairo_matrix_multiply (dst, &affine, dst);
             } else
                 return FALSE;
         } else if (!strcmp (keyword, "skewX")) {
             if (n_args != 1)
                 return FALSE;
-            _rsvg_affine_shear (tmp_affine, args[0]);
-            _rsvg_affine_multiply (dst, tmp_affine, dst);
+            _rsvg_cairo_matrix_init_shear (&affine, args[0]);
+            cairo_matrix_multiply (dst, &affine, dst);
         } else if (!strcmp (keyword, "skewY")) {
             if (n_args != 1)
                 return FALSE;
-            _rsvg_affine_shear (tmp_affine, args[0]);
+            _rsvg_cairo_matrix_init_shear (&affine, args[0]);
             /* transpose the affine, given that we know [1] is zero */
-            tmp_affine[1] = tmp_affine[2];
-            tmp_affine[2] = 0;
-            _rsvg_affine_multiply (dst, tmp_affine, dst);
+            affine.yx = affine.xy;
+            affine.xy = 0.;
+            cairo_matrix_multiply (dst, &affine, dst);
         } else
             return FALSE;       /* unknown keyword */
     }
@@ -1230,7 +1337,7 @@ rsvg_parse_transform (double dst[6], const char *src)
 }
 
 /**
- * rsvg_parse_transform_attr: Parse transform attribute and apply to state.
+ * rsvg_parse_transform_attr:
  * @ctx: Rsvg context.
  * @state: State in which to apply the transform.
  * @str: String containing transform.
@@ -1240,32 +1347,50 @@ rsvg_parse_transform (double dst[6], const char *src)
 static void
 rsvg_parse_transform_attr (RsvgHandle * ctx, RsvgState * state, const char *str)
 {
-    double affine[6];
+    cairo_matrix_t affine;
 
-    if (rsvg_parse_transform (affine, str)) {
-        _rsvg_affine_multiply (state->personal_affine, affine, state->personal_affine);
-        _rsvg_affine_multiply (state->affine, affine, state->affine);
+    if (rsvg_parse_transform (&affine, str)) {
+        cairo_matrix_multiply (&state->personal_affine, &affine, &state->personal_affine);
+        cairo_matrix_multiply (&state->affine, &affine, &state->affine);
     }
 }
 
+typedef struct _StylesData {
+    RsvgHandle *ctx;
+    RsvgState *state;
+} StylesData;
+
+static void
+apply_style (const gchar *key, StyleValueData *value, gpointer user_data)
+{
+    StylesData *data = (StylesData *) user_data;
+    rsvg_parse_style_pair (data->ctx, data->state, key, value->value, value->important);
+}
+
 static gboolean
 rsvg_lookup_apply_css_style (RsvgHandle * ctx, const char *target, RsvgState * state)
 {
-    const char *value = (const char *) g_hash_table_lookup (ctx->priv->css_props, target);
+    GHashTable *styles;
+
+    styles = g_hash_table_lookup (ctx->priv->css_props, target);
 
-    if (value != NULL) {
-        rsvg_parse_style (ctx, state, value);
+    if (styles != NULL) {
+        StylesData *data = g_new (StylesData, 1);
+        data->ctx = ctx;
+        data->state = state;
+        g_hash_table_foreach (styles, (GHFunc) apply_style, data);
+        g_free (data);
         return TRUE;
     }
     return FALSE;
 }
 
 /**
- * rsvg_parse_style_attrs: Parse style attribute.
+ * rsvg_parse_style_attrs:
  * @ctx: Rsvg context.
  * @state: Rsvg state
- * @tag: The SVG tag we're processing (eg: circle, ellipse), optionally %NULL
- * @klazz: The space delimited class list, optionally %NULL
+ * @tag: (nullable): The SVG tag we're processing (eg: circle, ellipse), optionally %NULL
+ * @klazz: (nullable): The space delimited class list, optionally %NULL
  * @atts: Attributes in SAX style.
  *
  * Parses style and transform attributes and modifies state at top of
@@ -1281,6 +1406,9 @@ rsvg_parse_style_attrs (RsvgHandle * ctx,
     gboolean found = FALSE;
     GString *klazz_list = NULL;
 
+    if (rsvg_property_bag_size (atts) > 0)
+        rsvg_parse_style_pairs (ctx, state, atts);
+
     /* Try to properly support all of the following, including inheritance:
      * *
      * #id
@@ -1295,6 +1423,11 @@ rsvg_parse_style_attrs (RsvgHandle * ctx,
     /* * */
     rsvg_lookup_apply_css_style (ctx, "*", state);
 
+    /* tag */
+    if (tag != NULL) {
+        rsvg_lookup_apply_css_style (ctx, tag, state);
+    }
+
     if (klazz != NULL) {
         i = strlen (klazz);
         while (j < i) {
@@ -1307,16 +1440,23 @@ rsvg_parse_style_attrs (RsvgHandle * ctx,
             while (j < i && !g_ascii_isspace (klazz[j]))
                 g_string_append_c (klazz_list, klazz[j++]);
 
-            /* tag.class */
-            if (tag != NULL && klazz_list->len != 1) {
-                target = g_strdup_printf ("%s%s", tag, klazz_list->str);
+            /* tag.class#id */
+            if (tag != NULL && klazz_list->len != 1 && id != NULL) {
+                target = g_strdup_printf ("%s%s#%s", tag, klazz_list->str, id);
                 found = found || rsvg_lookup_apply_css_style (ctx, target, state);
                 g_free (target);
             }
 
-            /* tag.class#id */
-            if (tag != NULL && klazz_list->len != 1 && id != NULL) {
-                target = g_strdup_printf ("%s%s#%s", tag, klazz_list->str, id);
+            /* class#id */
+            if (klazz_list->len != 1 && id != NULL) {
+                target = g_strdup_printf ("%s#%s", klazz_list->str, id);
+                found = found || rsvg_lookup_apply_css_style (ctx, target, state);
+                g_free (target);
+            }
+
+            /* tag.class */
+            if (tag != NULL && klazz_list->len != 1) {
+                target = g_strdup_printf ("%s%s", tag, klazz_list->str);
                 found = found || rsvg_lookup_apply_css_style (ctx, target, state);
                 g_free (target);
             }
@@ -1329,29 +1469,23 @@ rsvg_parse_style_attrs (RsvgHandle * ctx,
         }
     }
 
-    /* tag#id */
-    if (tag != NULL && id != NULL && !found) {
-        target = g_strdup_printf ("%s#%s", tag, id);
+    /* #id */
+    if (id != NULL) {
+        target = g_strdup_printf ("#%s", id);
         rsvg_lookup_apply_css_style (ctx, target, state);
         g_free (target);
     }
 
-    /* #id */
-    if (id != NULL && !found) {
-        target = g_strdup_printf ("#%s", id);
-        found = rsvg_lookup_apply_css_style (ctx, target, state);
+    /* tag#id */
+    if (tag != NULL && id != NULL) {
+        target = g_strdup_printf ("%s#%s", tag, id);
+        rsvg_lookup_apply_css_style (ctx, target, state);
         g_free (target);
     }
 
-    /* tag */
-    if (tag != NULL && !found)
-        found = rsvg_lookup_apply_css_style (ctx, tag, state);
-
     if (rsvg_property_bag_size (atts) > 0) {
         const char *value;
 
-        rsvg_parse_style_pairs (ctx, state, atts);
-
         if ((value = rsvg_property_bag_lookup (atts, "style")) != NULL)
             rsvg_parse_style (ctx, state, value);
         if ((value = rsvg_property_bag_lookup (atts, "transform")) != NULL)
@@ -1360,58 +1494,103 @@ rsvg_parse_style_attrs (RsvgHandle * ctx,
 }
 
 RsvgState *
-rsvg_state_current (RsvgDrawingCtx * ctx)
+rsvg_current_state (RsvgDrawingCtx * ctx)
 {
-    return g_slist_nth_data (ctx->state, 0);
+    return ctx->state;
 }
 
 RsvgState *
-rsvg_state_parent (RsvgDrawingCtx * ctx)
+rsvg_state_parent (RsvgState * state)
 {
-    return g_slist_nth_data (ctx->state, 1);
+    return state->parent;
 }
 
+void
+rsvg_state_free_all (RsvgState * state)
+{
+    while (state) {
+        RsvgState *parent = state->parent;
+        rsvg_state_finalize (state);
+        g_slice_free (RsvgState, state);
+        state = parent;
+    }
+}
+
+/**
+ * rsvg_property_bag_new:
+ * @atts: (array zero-terminated=1): list of alternating attributes
+ *   and values
+ * 
+ * The property bag will NOT copy the attributes and values. If you need
+ * to store them for later, use rsvg_property_bag_dup().
+ * 
+ * Returns: (transfer full): a new property bag
+ */
 RsvgPropertyBag *
 rsvg_property_bag_new (const char **atts)
 {
     RsvgPropertyBag *bag;
     int i;
 
-    bag = g_new (RsvgPropertyBag, 1);
-    bag->props = g_hash_table_new_full (g_str_hash, g_str_equal, NULL, NULL);
+    bag = g_hash_table_new (g_str_hash, g_str_equal);
 
     if (atts != NULL) {
         for (i = 0; atts[i] != NULL; i += 2)
-            g_hash_table_insert (bag->props, (gpointer) atts[i], (gpointer) atts[i + 1]);
+            g_hash_table_insert (bag, (gpointer) atts[i], (gpointer) atts[i + 1]);
     }
 
     return bag;
 }
 
+/**
+ * rsvg_property_bag_dup:
+ * @bag: property bag to duplicate
+ * 
+ * Returns a copy of @bag that owns the attributes and values.
+ * 
+ * Returns: (transfer full): a new property bag
+ */
+RsvgPropertyBag *
+rsvg_property_bag_dup (RsvgPropertyBag * bag)
+{
+    RsvgPropertyBag *dup;
+    GHashTableIter iter;
+    gpointer key, value;
+
+    dup = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
+
+    g_hash_table_iter_init (&iter, bag);
+    while (g_hash_table_iter_next (&iter, &key, &value))
+      g_hash_table_insert (dup, 
+                           (gpointer) g_strdup ((char *) key),
+                           (gpointer) g_strdup ((char *) value));
+
+    return dup;
+}
+
 void
 rsvg_property_bag_free (RsvgPropertyBag * bag)
 {
-    g_hash_table_destroy (bag->props);
-    g_free (bag);
+    g_hash_table_unref (bag);
 }
 
-G_CONST_RETURN char *
+const char *
 rsvg_property_bag_lookup (RsvgPropertyBag * bag, const char *key)
 {
-    return (const char *) g_hash_table_lookup (bag->props, (gconstpointer) key);
+    return (const char *) g_hash_table_lookup (bag, (gconstpointer) key);
 }
 
 guint
 rsvg_property_bag_size (RsvgPropertyBag * bag)
 {
-    return g_hash_table_size (bag->props);
+    return g_hash_table_size (bag);
 }
 
 void
 rsvg_property_bag_enumerate (RsvgPropertyBag * bag, RsvgPropertyBagEnumFunc func,
                              gpointer user_data)
 {
-    g_hash_table_foreach (bag->props, (GHFunc) func, user_data);
+    g_hash_table_foreach (bag, (GHFunc) func, user_data);
 }
 
 void
@@ -1420,29 +1599,25 @@ rsvg_state_push (RsvgDrawingCtx * ctx)
     RsvgState *data;
     RsvgState *baseon;
 
-    baseon = (RsvgState *) g_slist_nth_data (ctx->state, 0);
+    baseon = ctx->state;
     data = g_slice_new (RsvgState);
+    rsvg_state_init (data);
 
     if (baseon) {
-        int i;
-        rsvg_state_init (data);
         rsvg_state_reinherit (data, baseon);
-        for (i = 0; i < 6; i++)
-            data->affine[i] = baseon->affine[i];
-    } else
-        rsvg_state_init (data);
+        data->affine = baseon->affine;
+        data->parent = baseon;
+    }
 
-    ctx->state = g_slist_prepend (ctx->state, data);
+    ctx->state = data;
 }
 
 void
 rsvg_state_pop (RsvgDrawingCtx * ctx)
 {
-    GSList *link = g_slist_nth (ctx->state, 0);
-    RsvgState *dead_state = (RsvgState *) link->data;
-
+    RsvgState *dead_state = ctx->state;
+    ctx->state = dead_state->parent;
     rsvg_state_finalize (dead_state);
-    ctx->state = g_slist_delete_link (ctx->state, link);
     g_slice_free (RsvgState, dead_state);
 }
 
@@ -1463,34 +1638,27 @@ rsvg_state_pop (RsvgDrawingCtx * ctx)
 void
 rsvg_state_reinherit_top (RsvgDrawingCtx * ctx, RsvgState * state, int dominate)
 {
+    RsvgState *current;
+
     if (dominate == 3)
         return;
 
+    current = rsvg_current_state (ctx);
     /*This is a special domination mode for patterns, the transform
        is simply left as is, wheras the style is totally overridden */
     if (dominate == 2) {
-        rsvg_state_override (rsvg_state_current (ctx), state);
-    } else if (dominate) {
-        RsvgState *parent;
-        rsvg_state_clone (rsvg_state_current (ctx), state);
-
-        parent = rsvg_state_parent (ctx);
-        if (parent) {
-            rsvg_state_dominate (rsvg_state_current (ctx), rsvg_state_parent (ctx));
-            _rsvg_affine_multiply (rsvg_state_current (ctx)->affine,
-                                   rsvg_state_current (ctx)->affine,
-                                   rsvg_state_parent (ctx)->affine);
-        }
+        rsvg_state_override (current, state);
     } else {
-        RsvgState *parent;
-        rsvg_state_clone (rsvg_state_current (ctx), state);
-
-        parent = rsvg_state_parent (ctx);
+        RsvgState *parent= rsvg_state_parent (current);
+        rsvg_state_clone (current, state);
         if (parent) {
-            rsvg_state_reinherit (rsvg_state_current (ctx), rsvg_state_parent (ctx));
-            _rsvg_affine_multiply (rsvg_state_current (ctx)->affine,
-                                   rsvg_state_current (ctx)->affine,
-                                   rsvg_state_parent (ctx)->affine);
+            if (dominate)
+                rsvg_state_dominate (current, parent);
+            else
+                rsvg_state_reinherit (current, parent);
+            cairo_matrix_multiply (&current->affine,
+                                   &current->affine,
+                                   &parent->affine);
         }
     }
 }
